
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class BranchesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const branches = await db.branches.create(
            {
                id: data.id || undefined,
        
        branch_name: data.branch_name
        ||
        null
            ,
            
        branch_code: data.branch_code
        ||
        null
            ,
            
        phone: data.phone
        ||
        null
            ,
            
        email: data.email
        ||
        null
            ,
            
        address_line: data.address_line
        ||
        null
            ,
            
        city: data.city
        ||
        null
            ,
            
        region: data.region
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await branches.setCompany( data.company || null, {
            transaction,
        });
        
        await branches.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return branches;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const branchesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                branch_name: item.branch_name
            ||
            null
            ,
            
                branch_code: item.branch_code
            ||
            null
            ,
            
                phone: item.phone
            ||
            null
            ,
            
                email: item.email
            ||
            null
            ,
            
                address_line: item.address_line
            ||
            null
            ,
            
                city: item.city
            ||
            null
            ,
            
                region: item.region
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const branches = await db.branches.bulkCreate(branchesData, { transaction });

        // For each item created, replace relation files
        

        return branches;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const branches = await db.branches.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.branch_name !== undefined) updatePayload.branch_name = data.branch_name;
        
        
        if (data.branch_code !== undefined) updatePayload.branch_code = data.branch_code;
        
        
        if (data.phone !== undefined) updatePayload.phone = data.phone;
        
        
        if (data.email !== undefined) updatePayload.email = data.email;
        
        
        if (data.address_line !== undefined) updatePayload.address_line = data.address_line;
        
        
        if (data.city !== undefined) updatePayload.city = data.city;
        
        
        if (data.region !== undefined) updatePayload.region = data.region;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await branches.update(updatePayload, {transaction});

        
        
        if (data.company !== undefined) {
            await branches.setCompany(
              
              data.company,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await branches.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return branches;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const branches = await db.branches.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of branches) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of branches) {
                await record.destroy({transaction});
            }
        });


        return branches;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const branches = await db.branches.findByPk(id, options);

        await branches.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await branches.destroy({
            transaction
        });

        return branches;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const branches = await db.branches.findOne(
            { where },
            { transaction },
        );

        if (!branches) {
            return branches;
        }

        const output = branches.get({plain: true});

        
        
        
        
        
        
        
        output.user_roles_branch = await branches.getUser_roles_branch({
            transaction
        });
        
        
        output.audit_logs_branch = await branches.getAudit_logs_branch({
            transaction
        });
        
        
        
        
        output.price_lists_branch = await branches.getPrice_lists_branch({
            transaction
        });
        
        
        
        output.warehouses_branch = await branches.getWarehouses_branch({
            transaction
        });
        
        
        
        output.inventory_transactions_branch = await branches.getInventory_transactions_branch({
            transaction
        });
        
        
        output.stock_adjustments_branch = await branches.getStock_adjustments_branch({
            transaction
        });
        
        
        
        output.interbranch_transfers_from_branch = await branches.getInterbranch_transfers_from_branch({
            transaction
        });
        
        output.interbranch_transfers_to_branch = await branches.getInterbranch_transfers_to_branch({
            transaction
        });
        
        
        
        
        
        output.purchase_orders_branch = await branches.getPurchase_orders_branch({
            transaction
        });
        
        
        
        output.goods_receipts_branch = await branches.getGoods_receipts_branch({
            transaction
        });
        
        
        
        
        
        
        output.pos_registers_branch = await branches.getPos_registers_branch({
            transaction
        });
        
        
        output.pos_shifts_branch = await branches.getPos_shifts_branch({
            transaction
        });
        
        
        output.sales_branch = await branches.getSales_branch({
            transaction
        });
        
        
        
        
        
        output.store_checklists_branch = await branches.getStore_checklists_branch({
            transaction
        });
        
        
        
        output.checklist_runs_branch = await branches.getChecklist_runs_branch({
            transaction
        });
        
        
        
        output.risk_alerts_branch = await branches.getRisk_alerts_branch({
            transaction
        });
        
        
        
        output.employees_branch = await branches.getEmployees_branch({
            transaction
        });
        
        
        output.work_shifts_branch = await branches.getWork_shifts_branch({
            transaction
        });
        
        
        
        output.attendance_records_branch = await branches.getAttendance_records_branch({
            transaction
        });
        
        
        output.payroll_runs_branch = await branches.getPayroll_runs_branch({
            transaction
        });
        
        
        
        
        
        output.journal_entries_branch = await branches.getJournal_entries_branch({
            transaction
        });
        
        
        
        output.expenses_branch = await branches.getExpenses_branch({
            transaction
        });
        
        
        output.assets_branch = await branches.getAssets_branch({
            transaction
        });
        
        
        output.marketing_campaigns_branch = await branches.getMarketing_campaigns_branch({
            transaction
        });
        
        
        
        output.ai_reorder_suggestions_branch = await branches.getAi_reorder_suggestions_branch({
            transaction
        });
        
        
        
        output.company = await branches.getCompany({
            transaction
        });
        
        
        output.organizations = await branches.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.companies,
        as: 'company',
        
        where: filter.company ? {
          [Op.or]: [
            { id: { [Op.in]: filter.company.split('|').map(term => Utils.uuid(term)) } },
            {
              trade_name: {
                [Op.or]: filter.company.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.branch_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'branches',
                        'branch_name',
                        filter.branch_name,
                    ),
                };
            }
            
            if (filter.branch_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'branches',
                        'branch_code',
                        filter.branch_code,
                    ),
                };
            }
            
            if (filter.phone) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'branches',
                        'phone',
                        filter.phone,
                    ),
                };
            }
            
            if (filter.email) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'branches',
                        'email',
                        filter.email,
                    ),
                };
            }
            
            if (filter.address_line) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'branches',
                        'address_line',
                        filter.address_line,
                    ),
                };
            }
            
            if (filter.city) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'branches',
                        'city',
                        filter.city,
                    ),
                };
            }
            
            if (filter.region) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'branches',
                        'region',
                        filter.region,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.branches.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'branches',
                        'branch_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.branches.findAll({
            attributes: [ 'id', 'branch_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['branch_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.branch_name,
        }));
    }

    
};

